moDraw.fieldsprice = {};

function moDraw.fieldsprice:setOpenPdaSlot(self, slot, slotName)	
	if moFields == nil or moFields[1] == nil then
		moGuiExtras:closeOpenSlot(self, slot, true, false);
		g_currentMission:showBlinkingWarning(tostring(moLanguageXml:getTxt("slotno")), 2500);
		return;
	end;
	----
	if moGuiMiniPdaSlots.values[slot].permUpdate then MultiOverlayV2:setSlotUpdate(self, slot);end;
	moGuiExtras:setSlotMaxProSwitch(self, slot);
	moGuiExtras:setSlotFirstEndObjects(self, slot);
	local firstObjectDisplay, endObjectDisplay = moGuiMiniPdaSlots.values[slot].firstObject, moGuiMiniPdaSlots.values[slot].endObject;
	local tempObjectDisplay = 0;
	----
	moGuiMiniPdaSlots.values[slot].clickArea.slotFieldBuy = {};
	local hotSpot = moGuiMiniPdaSlots.values[slot].hotSpot;
	if hotSpot then moGuiMiniPdaSlots.values[slot].clickArea.slotHotSpot = {};end;
	local posX = moGuiMiniPdaSlots.values[slot].openX+0.001;
	local posY = moGuiMiniPdaSlots.values[slot].openY;
	local size = moGuiMiniPdaSlots.values[slot].size;
	local distanceLine = moGuiMiniPdaSlots.values[slot].distanceLine;
	local widthSettings = moSetGetGui.buttonGfxWidth1*moSetGetGui.zoomOutInTemp*4;
	local heightSettings = moSetGetGui.buttonGfxHeight1*moSetGetGui.zoomOutInTemp*4;	
	local height = moSetGetGui.buttonGfxHeight1*(size*1000);
	local heightDefault = moSetGetGui.buttonGfxHeight1*(size*1000);
	local distanceDif = moGuiMiniPdaSlots.values[slot].distanceDif; --fillcontainer <----> filllevel
	local slotLength = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(moGuiMiniPdaSlots.values[slot].length+moSetGetGui.screenAspectRatio);	
	local width = slotLength+distanceDif;	
	local widthNext = 0;
	local line = 20;
	local defaultSwitch = 20;
	local currentPosY = posY;
	function nextLine(setHeight, posYnew, setLine, posYline, widthLine, heightLine, onlyLine)
		if setLine then
			moSetGetGui:setOverlay(self, moSetGetGui["designLine"], posX+widthNext-0.001, currentPosY-(posYline), widthLine, heightLine);
			moSetGetGui["designLine"]:render();
			if onlyLine then return;end;
		end;		
		if setHeight then height = height+(heightDefault)+posYnew;end; --height+size+posNew;
		currentPosY = currentPosY-(heightDefault)-posYnew; --posY-(size+posYnew);		
	end;	
	moSetGetGui["designGround".. slot]:render();
	setTextBold(true);	
	setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
	local sizeTemp = 0.010;
	if size < sizeTemp then sizeTemp = size;end;
	if moGuiMiniPdaSlots.keySwitchLast == slot then
		if not moGuiMiniPdaSlots.values[slot].settings then
			moSetGetGui["slotCfg"]:setPosition(posX, posY);
			moSetGetGui["slotCfg"]:render();
		else
			moSetGetGui["slotPos"]:setPosition(posX, posY);
			moSetGetGui["slotPos"]:render();
		end;
		nextLine(true, 0.005, false);		
		moSetGetGui["slotFruit"]:setPosition(posX+(widthSettings*1), posY);
		moSetGetGui["slotFruit"]:render();
		moSetGetGui["slotNotReady"]:setPosition(posX+(widthSettings*1), posY);
		moSetGetGui["slotNotReady"]:render();
		moSetGetGui["slotMoney"]:setPosition(posX+(widthSettings*2), posY);
		moSetGetGui["slotMoney"]:render();		
		moSetGetGui["slotNotReady"]:setPosition(posX+(widthSettings*2), posY);
		moSetGetGui["slotNotReady"]:render();
		moSetGetGui["slotPlus"]:setPosition(posX+(widthSettings*3), posY);
		moSetGetGui["slotPlus"]:render();		
		if moGuiMiniPdaSlots.values[slot].seeSmall then
			moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*3), posY);
			moSetGetGui["slotNotOkay"]:render();
		end;
		if not moGuiMiniPdaSlots.values[slot].hotSpot then
			moSetGetGui["slotHotSpot"]:setPosition(posX, posY-(heightSettings));
			moSetGetGui["slotHotSpot"]:render();
			moSetGetGui["slotNotOkay"]:setPosition(posX, posY-(heightSettings));
			moSetGetGui["slotNotOkay"]:render();
		else
			if moGuiMiniPdaSlots.isHotSpotObj then
				if moGuiMiniPdaSlots.hotSpotBlinkTemp <= moGuiMiniPdaSlots.hotSpotBlinkTime then --warningBlinkTime, warningBlinkTemp
					moGuiMiniPdaSlots.hotSpotBlinkTemp = moGuiMiniPdaSlots.hotSpotBlinkTemp+1			
					moSetGetGui["slotHotSpot"]:setPosition(posX, posY-(heightSettings));
					moSetGetGui["slotHotSpot"]:render();			
				else
					moGuiMiniPdaSlots.hotSpotBlinkTemp = moGuiMiniPdaSlots.hotSpotBlinkTemp+1
					if moGuiMiniPdaSlots.hotSpotBlinkTemp >= moGuiMiniPdaSlots.hotSpotBlinkTime*2 then moGuiMiniPdaSlots.hotSpotBlinkTemp = 0;end;
				end;
			else
				moSetGetGui["slotHotSpot"]:setPosition(posX, posY-(heightSettings));
				moSetGetGui["slotHotSpot"]:render();
			end;
		end;					
		moSetGetGui["slotSwitchL"]:setPosition(posX+(widthSettings*4), posY);
		moSetGetGui["slotSwitchL"]:render();
		renderText(posX+(widthSettings*4.7), posY+0.0035, sizeTemp, tostring(moGuiMiniPdaSlots.values[slot].switch));
		moSetGetGui["slotSwitchR"]:setPosition(posX+(widthSettings*5), posY);
		moSetGetGui["slotSwitchR"]:render();
		moSetGetGui["slotNextL"]:setPosition(posX+(widthSettings*6), posY);
		moSetGetGui["slotNextL"]:render();
		moSetGetGui["slotNextR"]:setPosition(posX+(widthSettings*8), posY);
		moSetGetGui["slotNextR"]:render();
		renderText(posX+(widthSettings*7.05), posY+0.0035, sizeTemp, tostring(moGuiMiniPdaSlots.values[slot].maxProSwitch));					
	else
		moSetGetGui["slotNotReady"]:setPosition(posX, posY-(heightSettings));
		moSetGetGui["slotNotReady"]:render();
		nextLine(true, 0.005, false);
		renderText(posX, posY+0.0035, sizeTemp, "Slotname:  ".. tostring(moGuiMiniPdaSlots.values[slot].name));
	end;	
	----
	renderText(posX+(widthSettings*1.1), currentPosY, size, tostring(moLanguageXml:getTxt("fields")).. ": ".. tostring(firstObjectDisplay).. "-".. tostring(endObjectDisplay));
	setTextAlignment(RenderText.ALIGN_RIGHT);
	setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
	renderText(posX+width-distanceDif, currentPosY, size, tostring(moGuiMiniPdaSlots.values[slot].foundObjects));		
	setTextAlignment(false);	
	nextLine(true, 0.007, true, 0.0035, width+widthNext, 0.001);
	local saveFirstY = currentPosY;
	local setHeight = true;
	local lastFirstY = 0;	
	----
	if firstObjectDisplay <= moFields.fieldsMax then
		for a=firstObjectDisplay, moFields.fieldsMax do		
			if moFields[a] ~= nil and moFields[a].fieldNumber ~= nil then
				tempObjectDisplay = tempObjectDisplay+1;
				--if tonumber(tempObjectDisplay) >= tonumber(firstObjectDisplay) then					
					if tonumber(a) > tonumber(endObjectDisplay) then break;end;
					--firstObjectDisplay = firstObjectDisplay+1;
					if moGuiMiniPdaSlots.values[slot].maxProSwitch > 20 then
						if tonumber(tempObjectDisplay) > tonumber(line) then line = line+20;setHeight = false;lastFirstY = currentPosY;currentPosY = saveFirstY;widthNext = widthNext+width+0.002;end;
					end;					
					setTextColor(unpack(moGuiMiniPdaSlots.inactiveColor));
					setTextBold(false);
					local price = g_i18n:formatMoney(moFields[a].price);
					if not moFields[a].isBuy and not g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber[a].ownedByPlayer then
						setTextBold(true);
						setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
						if moFields.userId ~= nil and moFields.userId > 0 then
							local money = g_currentMission.missionStats.money; --g_currentMission:getMoney(moFields.userId);
							if money >= moFields[a].price then 
								setTextColor(unpack(moGuiMiniPdaSlots.warningColor0));
								if moFields[a].fieldObject.fieldBuyTrigger ~= nil and moFields[a].fieldObject.fieldBuyTrigger ~= 0 then moDraw.fieldsprice:setClickAreaFieldBuy(self, posX+widthNext+width/2, currentPosY, width/2, heightDefault, a, slot);end;
							else
								setTextColor(unpack(moGuiMiniPdaSlots.warningColor3));
							end;
						end;
					end;				
					renderText(posX+widthNext, currentPosY, size, tostring(moLanguageXml:getTxt("field")).. " ".. tonumber(moFields[a].fieldNumber));					
					if hotSpot then moDraw.fieldsprice:setClickAreaHotSpot(self, posX+widthNext, currentPosY, width/2, heightDefault, moFields[a].x, moFields[a].z, tostring(moLanguageXml:getTxt("field")).. " ".. tonumber(moFields[a].fieldNumber), slot);end;
					setTextAlignment(RenderText.ALIGN_RIGHT);
					renderText(posX+width+widthNext-distanceDif, currentPosY, size, tostring(price));	
					if not moGuiMiniPdaSlots.values[slot].seeSmall then
						nextLine(setHeight, distanceLine/2, false);	
						setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
						setTextBold(false);
						setTextAlignment(false);
						renderText(posX+widthNext, currentPosY, size, tostring(moLanguageXml:getTxt("hectar")));					
						setTextAlignment(RenderText.ALIGN_RIGHT);
						local hectar = string.format("%.2f", Utils.getNoNil(moFields[a].hectar,0));
						renderText(posX+width+widthNext-distanceDif, currentPosY, size, tostring(hectar));					
					end;
					setTextAlignment(false);
					nextLine(setHeight, distanceLine, true, 0.0035, width, 0.001);
				--end;
			end;
		end;
	end;	
	----	
	if lastFirstY == 0 then
		moSetGetGui:setOverlay(self, moSetGetGui["designGround".. slot], posX-0.001, currentPosY+(heightSettings/2), width+widthNext, height+(heightSettings/2)); --+heightSettings
	else
		moSetGetGui:setOverlay(self, moSetGetGui["designGround".. slot], posX-0.001, lastFirstY+(heightSettings/2), width+widthNext, height+(heightSettings/2)); --+heightSettings
	end;
	moGuiMiniPdaSlots.values[slot].openLastWidth = width+widthNext;
	moGuiMiniPdaSlots.values[slot].openLastHeight = height+(heightSettings/2); --+heightSettings	
	setTextColor(1, 1, 1, 1);
	setTextAlignment(false);
	setTextBold(false);	
end;

function moDraw.fieldsprice:setClickAreaHotSpot(self, posX, posY, horizontal, vertical, objX, objZ, name, slot)	
	if objX == nil or objZ == nil then return;end;
	local a = Utils.getNoNil(table.getn(moGuiMiniPdaSlots.values[slot].clickArea.slotHotSpot), 0);	
	moGuiMiniPdaSlots.values[slot].clickArea.slotHotSpot[a+1] = {posX, posX+(horizontal), posY, posY+(vertical), objX, objZ, name };
end;

function moDraw.fieldsprice:setClickAreaFieldBuy(self, posX, posY, horizontal, vertical, fieldNum, slot)	
	if fieldNum == nil then return;end;
	local a = Utils.getNoNil(table.getn(moGuiMiniPdaSlots.values[slot].clickArea.slotFieldBuy), 0);	
	moGuiMiniPdaSlots.values[slot].clickArea.slotFieldBuy[a+1] = {posX, posX+(horizontal), posY, posY+(vertical), fieldNum };
end;